using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;
using System.ServiceModel;

namespace Benday.SilverlightFaults
{
    public partial class Home : Page
    {
        public Home()
        {
            InitializeComponent();
        }

        // Executes when the user navigates to this page.
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void m_btnUpdateTime_Click(object sender, RoutedEventArgs e)
        {
            CallService(false);
        }

        private void CallService(bool throwException)
        {
            try
            {
                TestService.TestServiceClient client = new TestService.TestServiceClient();
                client.GetTimeCompleted += new EventHandler<TestService.GetTimeCompletedEventArgs>(client_GetTimeCompleted);
                client.GetTimeAsync(throwException);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        void client_GetTimeCompleted(object sender, TestService.GetTimeCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                m_textError.Text = String.Empty;
                m_textTimeOnServer.Text = e.Result;                
            }
            else if (e.Error is FaultException<ExceptionDetail>)
            {
                FaultException<ExceptionDetail> fault = e.Error as FaultException<ExceptionDetail>;

                m_textTimeOnServer.Text = "(server threw FaultException<ExceptionDetail>)";
                m_textError.Text =
                    String.Format("{0}{1}{1}{2}", fault.Detail.Message, Environment.NewLine, fault.Detail);
            }
            else
            {
                m_textTimeOnServer.Text = "(server threw an error)";
                m_textError.Text =
                    String.Format("{0}{1}{1}{2}", e.Error.Message, Environment.NewLine, e.Error.ToString());
            }
        }

        private void m_btnUpdateTimeAndThrowException_Click(object sender, RoutedEventArgs e)
        {
            CallService(true);
        }
    }
}
